#pragma once
#include <LiquidCrystal.h>
#include "state.h"
#include "station.h"
#include "context.h"

class StateMachine {
private:
    State* currentState;
    void updateState(State* newState);

public:
    StateMachine(State* initialState);
    ~StateMachine();

    void pickedUp(const Context& context);
    void putDown(const Context& context, Station* newStation);
    void update(const Context& context);

    String updateDisplay() const;
};
